#!/usr/bin/env bash

. /lib/lsb/init-functions

NAME="mesos-master"
DESC="mesos-master"

BASEMAPR=${MAPR_HOME:-/opt/mapr}
PATH=$PATH:/sbin:/usr/sbin:/bin:/usr/bin
PID=${BASEMAPR}/pid/mesos-master.pid

start() {
  start-stop-daemon --start --background --quiet \
                      --pidfile "$PID" --make-pidfile \
                      --exec /usr/bin/mesos-init-wrapper master
}

stop() {
  start-stop-daemon --stop --quiet --pidfile "$PID"
}

case "${1-}" in
  start)
     echo -n "Starting $DESC: "
     start
     echo "$NAME."
     ;;
  stop)
     echo -n "Stopping $DESC: "
     stop
     echo "$NAME."
     ;;
  restart)
     echo -n "Restarting $DESC: "
     stop
     sleep 1
     start
     echo "$NAME."
     ;;
  status)
     status_of_proc -p "$PID" "$NAME" "$NAME" && exit 0 || exit $?
     ;;
  *)
     echo "Usage: $0 {start|stop|restart|status}" >&2
     exit 1
     ;;
 esac
